/*:ts=8*/
/*****************************************************************************
 * FIDOGATE --- Gateway UNIX Mail/News <-> FIDO NetMail/EchoMail
 *
 * $Id: fopen.c,v 3.9.7.0 1996/02/09 17:48:55 mj Exp mj $
 *
 * Specialized fopen()-like functions
 *
 *****************************************************************************
 * Copyright (C) 1990-1996
 *  _____ _____
 * |     |___  |   Martin Junius             FIDO:      2:2452/110
 * | | | |   | |   Republikplatz 3           Internet:  mj@fido.de
 * |_|_|_|@home|   D-52072 Aachen, Germany
 *
 * This file is part of FIDOGATE.
 *
 * FIDOGATE is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * FIDOGATE is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with FIDOGATE; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/

#include "fidogate.h"



/*
 * xfopen() --- expand file name, open file, check for error
 */

FILE *xfopen(name, mode)
    char *name, *mode;
{
    FILE *fp;
    char xname[MAXPATH];
    
    if(!name)
	return NULL;
    
    str_expand_name(xname, sizeof(xname), name);
    
    if((fp = fopen(xname, mode)) == NULL) {
	log("$ERROR: can't open %s", xname);
	exit(EX_OSFILE);
    }
    return(fp);
}



/*
 * libfopen() --- open file in LIBDIR, check for error
 */

FILE *libfopen(name, mode)
    char *name, *mode;
{
    char filename[MAXPATH];

    BUF_COPY3(filename, cf_libdir(), "/", name);

    return xfopen(filename, mode);
}



/*
 * spoolfopen() --- open file in SPOOLDIR, check for error
 */

FILE *spoolfopen(name, mode)
    char *name, *mode;
{
    char filename[MAXPATH];

    BUF_COPY3(filename, cf_spooldir(), "/", name);

    return xfopen(filename, mode);
}
